<template>
    <div>
        <form @submit.prevent="upload">
            <div class="form-group">
                <label for="path">Ścieżka do pliku</label>
                <input type="text" class="form-control" name="path" id="path" v-model="fields.path" />
                <div v-if="errors && errors.path" class="text-danger">{{ errors.path[0] }}</div>
            </div>
            <button type="submit" class="btn btn-primary">Dalej</button>
        </form>
        <br/>    
        <br/>
        <div id="criteria" class="row"></div>
        <div id="pdf" class="d-none">
            <a href="/uploads/specyfikacja.pdf">PDF</a>
        </div>
    </div>
</template>

<script>

const default_layout = "default";

export default {
    /**
     * Criteria
     *
     * @var array
     */
    criteria: [],

    /**
     * Data
     *
     * @var object
     */
    data() {
        return {
            fields: {},
            errors: {},
        }
    },

    /**
     * Methods
     *
     * @var object
     */
    methods: {
        /**
         * Load criteria xlsx
         *
         * After criteria file is loaded
         * the firs one is displayed as select.
         *
         * @return void
         */
        upload() {
            this.errors = {};
            axios.post('/upload', this.fields).then(response => {
                this.criteria = response.data;
                this.showNextCriteria();
            }).catch(error => {
                if (error.response.status === 422) {
                    this.errors = error.response.data.errors || {};
                }
            });
        },
        
        /**
         * Displays next criteria select
         *
         * First time is executed when criteria file is loaded.
         * Next after last criteria is selected, unless it's the last one.
         * In this case is displayed link to download pdf.
         *
         * @return void
         */
        showNextCriteria() {
            $('.criteria-select').attr('disabled',true);
            if(this.criteria.length){
                var item = this.criteria[0];
                this.criteria.splice(0,1);
                this.generateSelect(item);
            }else{
                $('#pdf').removeClass('d-none');
            }
        },
        
        /**
         * Generate single criteria select
         *
         * @return void
         */
        generateSelect(item){
            var that = this;
            axios.get('/criteria/load-select/'+JSON.stringify(item)).then(response => {
                $('#criteria').append(response.data);
                $('.criteria-select').on('change',function(){
                    that.showNextCriteria();
                });
            });
        },
    },
};

</script>
